// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from system_modes_msgs:msg/ModeEvent.idl
// generated code does not contain a copyright notice
#include "system_modes_msgs/msg/detail/mode_event__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `start_mode`
// Member `goal_mode`
#include "system_modes_msgs/msg/detail/mode__functions.h"

bool
system_modes_msgs__msg__ModeEvent__init(system_modes_msgs__msg__ModeEvent * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  // start_mode
  if (!system_modes_msgs__msg__Mode__init(&msg->start_mode)) {
    system_modes_msgs__msg__ModeEvent__fini(msg);
    return false;
  }
  // goal_mode
  if (!system_modes_msgs__msg__Mode__init(&msg->goal_mode)) {
    system_modes_msgs__msg__ModeEvent__fini(msg);
    return false;
  }
  return true;
}

void
system_modes_msgs__msg__ModeEvent__fini(system_modes_msgs__msg__ModeEvent * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  // start_mode
  system_modes_msgs__msg__Mode__fini(&msg->start_mode);
  // goal_mode
  system_modes_msgs__msg__Mode__fini(&msg->goal_mode);
}

bool
system_modes_msgs__msg__ModeEvent__are_equal(const system_modes_msgs__msg__ModeEvent * lhs, const system_modes_msgs__msg__ModeEvent * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (lhs->timestamp != rhs->timestamp) {
    return false;
  }
  // start_mode
  if (!system_modes_msgs__msg__Mode__are_equal(
      &(lhs->start_mode), &(rhs->start_mode)))
  {
    return false;
  }
  // goal_mode
  if (!system_modes_msgs__msg__Mode__are_equal(
      &(lhs->goal_mode), &(rhs->goal_mode)))
  {
    return false;
  }
  return true;
}

bool
system_modes_msgs__msg__ModeEvent__copy(
  const system_modes_msgs__msg__ModeEvent * input,
  system_modes_msgs__msg__ModeEvent * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  output->timestamp = input->timestamp;
  // start_mode
  if (!system_modes_msgs__msg__Mode__copy(
      &(input->start_mode), &(output->start_mode)))
  {
    return false;
  }
  // goal_mode
  if (!system_modes_msgs__msg__Mode__copy(
      &(input->goal_mode), &(output->goal_mode)))
  {
    return false;
  }
  return true;
}

system_modes_msgs__msg__ModeEvent *
system_modes_msgs__msg__ModeEvent__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__msg__ModeEvent * msg = (system_modes_msgs__msg__ModeEvent *)allocator.allocate(sizeof(system_modes_msgs__msg__ModeEvent), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(system_modes_msgs__msg__ModeEvent));
  bool success = system_modes_msgs__msg__ModeEvent__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
system_modes_msgs__msg__ModeEvent__destroy(system_modes_msgs__msg__ModeEvent * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    system_modes_msgs__msg__ModeEvent__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
system_modes_msgs__msg__ModeEvent__Sequence__init(system_modes_msgs__msg__ModeEvent__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__msg__ModeEvent * data = NULL;

  if (size) {
    data = (system_modes_msgs__msg__ModeEvent *)allocator.zero_allocate(size, sizeof(system_modes_msgs__msg__ModeEvent), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = system_modes_msgs__msg__ModeEvent__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        system_modes_msgs__msg__ModeEvent__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
system_modes_msgs__msg__ModeEvent__Sequence__fini(system_modes_msgs__msg__ModeEvent__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      system_modes_msgs__msg__ModeEvent__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

system_modes_msgs__msg__ModeEvent__Sequence *
system_modes_msgs__msg__ModeEvent__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  system_modes_msgs__msg__ModeEvent__Sequence * array = (system_modes_msgs__msg__ModeEvent__Sequence *)allocator.allocate(sizeof(system_modes_msgs__msg__ModeEvent__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = system_modes_msgs__msg__ModeEvent__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
system_modes_msgs__msg__ModeEvent__Sequence__destroy(system_modes_msgs__msg__ModeEvent__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    system_modes_msgs__msg__ModeEvent__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
system_modes_msgs__msg__ModeEvent__Sequence__are_equal(const system_modes_msgs__msg__ModeEvent__Sequence * lhs, const system_modes_msgs__msg__ModeEvent__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!system_modes_msgs__msg__ModeEvent__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
system_modes_msgs__msg__ModeEvent__Sequence__copy(
  const system_modes_msgs__msg__ModeEvent__Sequence * input,
  system_modes_msgs__msg__ModeEvent__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(system_modes_msgs__msg__ModeEvent);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    system_modes_msgs__msg__ModeEvent * data =
      (system_modes_msgs__msg__ModeEvent *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!system_modes_msgs__msg__ModeEvent__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          system_modes_msgs__msg__ModeEvent__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!system_modes_msgs__msg__ModeEvent__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
