// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from system_modes_msgs:msg/ModeEvent.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "system_modes_msgs/msg/mode_event.hpp"


#ifndef SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__STRUCT_HPP_
#define SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'start_mode'
// Member 'goal_mode'
#include "system_modes_msgs/msg/detail/mode__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__system_modes_msgs__msg__ModeEvent __attribute__((deprecated))
#else
# define DEPRECATED__system_modes_msgs__msg__ModeEvent __declspec(deprecated)
#endif

namespace system_modes_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ModeEvent_
{
  using Type = ModeEvent_<ContainerAllocator>;

  explicit ModeEvent_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start_mode(_init),
    goal_mode(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
    }
  }

  explicit ModeEvent_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start_mode(_alloc, _init),
    goal_mode(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->timestamp = 0ull;
    }
  }

  // field types and members
  using _timestamp_type =
    uint64_t;
  _timestamp_type timestamp;
  using _start_mode_type =
    system_modes_msgs::msg::Mode_<ContainerAllocator>;
  _start_mode_type start_mode;
  using _goal_mode_type =
    system_modes_msgs::msg::Mode_<ContainerAllocator>;
  _goal_mode_type goal_mode;

  // setters for named parameter idiom
  Type & set__timestamp(
    const uint64_t & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__start_mode(
    const system_modes_msgs::msg::Mode_<ContainerAllocator> & _arg)
  {
    this->start_mode = _arg;
    return *this;
  }
  Type & set__goal_mode(
    const system_modes_msgs::msg::Mode_<ContainerAllocator> & _arg)
  {
    this->goal_mode = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    system_modes_msgs::msg::ModeEvent_<ContainerAllocator> *;
  using ConstRawPtr =
    const system_modes_msgs::msg::ModeEvent_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<system_modes_msgs::msg::ModeEvent_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<system_modes_msgs::msg::ModeEvent_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      system_modes_msgs::msg::ModeEvent_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<system_modes_msgs::msg::ModeEvent_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      system_modes_msgs::msg::ModeEvent_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<system_modes_msgs::msg::ModeEvent_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<system_modes_msgs::msg::ModeEvent_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<system_modes_msgs::msg::ModeEvent_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__system_modes_msgs__msg__ModeEvent
    std::shared_ptr<system_modes_msgs::msg::ModeEvent_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__system_modes_msgs__msg__ModeEvent
    std::shared_ptr<system_modes_msgs::msg::ModeEvent_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ModeEvent_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->start_mode != other.start_mode) {
      return false;
    }
    if (this->goal_mode != other.goal_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const ModeEvent_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ModeEvent_

// alias to use template instance with default allocator
using ModeEvent =
  system_modes_msgs::msg::ModeEvent_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace system_modes_msgs

#endif  // SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__STRUCT_HPP_
