// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from system_modes_msgs:msg/ModeEvent.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "system_modes_msgs/msg/mode_event.hpp"


#ifndef SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__TRAITS_HPP_
#define SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "system_modes_msgs/msg/detail/mode_event__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'start_mode'
// Member 'goal_mode'
#include "system_modes_msgs/msg/detail/mode__traits.hpp"

namespace system_modes_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ModeEvent & msg,
  std::ostream & out)
{
  out << "{";
  // member: timestamp
  {
    out << "timestamp: ";
    rosidl_generator_traits::value_to_yaml(msg.timestamp, out);
    out << ", ";
  }

  // member: start_mode
  {
    out << "start_mode: ";
    to_flow_style_yaml(msg.start_mode, out);
    out << ", ";
  }

  // member: goal_mode
  {
    out << "goal_mode: ";
    to_flow_style_yaml(msg.goal_mode, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ModeEvent & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp: ";
    rosidl_generator_traits::value_to_yaml(msg.timestamp, out);
    out << "\n";
  }

  // member: start_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_mode:\n";
    to_block_style_yaml(msg.start_mode, out, indentation + 2);
  }

  // member: goal_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_mode:\n";
    to_block_style_yaml(msg.goal_mode, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ModeEvent & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace system_modes_msgs

namespace rosidl_generator_traits
{

[[deprecated("use system_modes_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const system_modes_msgs::msg::ModeEvent & msg,
  std::ostream & out, size_t indentation = 0)
{
  system_modes_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use system_modes_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const system_modes_msgs::msg::ModeEvent & msg)
{
  return system_modes_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<system_modes_msgs::msg::ModeEvent>()
{
  return "system_modes_msgs::msg::ModeEvent";
}

template<>
inline const char * name<system_modes_msgs::msg::ModeEvent>()
{
  return "system_modes_msgs/msg/ModeEvent";
}

template<>
struct has_fixed_size<system_modes_msgs::msg::ModeEvent>
  : std::integral_constant<bool, has_fixed_size<system_modes_msgs::msg::Mode>::value> {};

template<>
struct has_bounded_size<system_modes_msgs::msg::ModeEvent>
  : std::integral_constant<bool, has_bounded_size<system_modes_msgs::msg::Mode>::value> {};

template<>
struct is_message<system_modes_msgs::msg::ModeEvent>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__TRAITS_HPP_
