// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from system_modes_msgs:msg/ModeEvent.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "system_modes_msgs/msg/mode_event.h"


#ifndef SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__STRUCT_H_
#define SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'start_mode'
// Member 'goal_mode'
#include "system_modes_msgs/msg/detail/mode__struct.h"

/// Struct defined in msg/ModeEvent in the package system_modes_msgs.
/**
  * The time point at which this event occurred.
 */
typedef struct system_modes_msgs__msg__ModeEvent
{
  uint64_t timestamp;
  /// The starting mode from which this event transitioned.
  system_modes_msgs__msg__Mode start_mode;
  /// The end mode of this transition event.
  system_modes_msgs__msg__Mode goal_mode;
} system_modes_msgs__msg__ModeEvent;

// Struct for a sequence of system_modes_msgs__msg__ModeEvent.
typedef struct system_modes_msgs__msg__ModeEvent__Sequence
{
  system_modes_msgs__msg__ModeEvent * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} system_modes_msgs__msg__ModeEvent__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // SYSTEM_MODES_MSGS__MSG__DETAIL__MODE_EVENT__STRUCT_H_
