// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from system_modes_msgs:msg/ModeEvent.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "system_modes_msgs/msg/detail/mode_event__functions.h"
#include "system_modes_msgs/msg/detail/mode_event__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace system_modes_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void ModeEvent_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) system_modes_msgs::msg::ModeEvent(_init);
}

void ModeEvent_fini_function(void * message_memory)
{
  auto typed_message = static_cast<system_modes_msgs::msg::ModeEvent *>(message_memory);
  typed_message->~ModeEvent();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ModeEvent_message_member_array[3] = {
  {
    "timestamp",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT64,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(system_modes_msgs::msg::ModeEvent, timestamp),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "start_mode",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<system_modes_msgs::msg::Mode>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(system_modes_msgs::msg::ModeEvent, start_mode),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "goal_mode",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<system_modes_msgs::msg::Mode>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(system_modes_msgs::msg::ModeEvent, goal_mode),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ModeEvent_message_members = {
  "system_modes_msgs::msg",  // message namespace
  "ModeEvent",  // message name
  3,  // number of fields
  sizeof(system_modes_msgs::msg::ModeEvent),
  false,  // has_any_key_member_
  ModeEvent_message_member_array,  // message members
  ModeEvent_init_function,  // function to initialize message memory (memory has to be allocated)
  ModeEvent_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t ModeEvent_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ModeEvent_message_members,
  get_message_typesupport_handle_function,
  &system_modes_msgs__msg__ModeEvent__get_type_hash,
  &system_modes_msgs__msg__ModeEvent__get_type_description,
  &system_modes_msgs__msg__ModeEvent__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace system_modes_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<system_modes_msgs::msg::ModeEvent>()
{
  return &::system_modes_msgs::msg::rosidl_typesupport_introspection_cpp::ModeEvent_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, system_modes_msgs, msg, ModeEvent)() {
  return &::system_modes_msgs::msg::rosidl_typesupport_introspection_cpp::ModeEvent_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
