// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from system_modes_msgs:srv/GetMode.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "system_modes_msgs/srv/get_mode.hpp"


#ifndef SYSTEM_MODES_MSGS__SRV__DETAIL__GET_MODE__STRUCT_HPP_
#define SYSTEM_MODES_MSGS__SRV__DETAIL__GET_MODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__system_modes_msgs__srv__GetMode_Request __attribute__((deprecated))
#else
# define DEPRECATED__system_modes_msgs__srv__GetMode_Request __declspec(deprecated)
#endif

namespace system_modes_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMode_Request_
{
  using Type = GetMode_Request_<ContainerAllocator>;

  explicit GetMode_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit GetMode_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    system_modes_msgs::srv::GetMode_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const system_modes_msgs::srv::GetMode_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__system_modes_msgs__srv__GetMode_Request
    std::shared_ptr<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__system_modes_msgs__srv__GetMode_Request
    std::shared_ptr<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMode_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMode_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMode_Request_

// alias to use template instance with default allocator
using GetMode_Request =
  system_modes_msgs::srv::GetMode_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace system_modes_msgs


#ifndef _WIN32
# define DEPRECATED__system_modes_msgs__srv__GetMode_Response __attribute__((deprecated))
#else
# define DEPRECATED__system_modes_msgs__srv__GetMode_Response __declspec(deprecated)
#endif

namespace system_modes_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMode_Response_
{
  using Type = GetMode_Response_<ContainerAllocator>;

  explicit GetMode_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->current_mode = "";
    }
  }

  explicit GetMode_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : current_mode(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->current_mode = "";
    }
  }

  // field types and members
  using _current_mode_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _current_mode_type current_mode;

  // setters for named parameter idiom
  Type & set__current_mode(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->current_mode = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    system_modes_msgs::srv::GetMode_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const system_modes_msgs::srv::GetMode_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__system_modes_msgs__srv__GetMode_Response
    std::shared_ptr<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__system_modes_msgs__srv__GetMode_Response
    std::shared_ptr<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMode_Response_ & other) const
  {
    if (this->current_mode != other.current_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMode_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMode_Response_

// alias to use template instance with default allocator
using GetMode_Response =
  system_modes_msgs::srv::GetMode_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace system_modes_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__system_modes_msgs__srv__GetMode_Event __attribute__((deprecated))
#else
# define DEPRECATED__system_modes_msgs__srv__GetMode_Event __declspec(deprecated)
#endif

namespace system_modes_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMode_Event_
{
  using Type = GetMode_Event_<ContainerAllocator>;

  explicit GetMode_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit GetMode_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<system_modes_msgs::srv::GetMode_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<system_modes_msgs::srv::GetMode_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    system_modes_msgs::srv::GetMode_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const system_modes_msgs::srv::GetMode_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<system_modes_msgs::srv::GetMode_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<system_modes_msgs::srv::GetMode_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      system_modes_msgs::srv::GetMode_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<system_modes_msgs::srv::GetMode_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      system_modes_msgs::srv::GetMode_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<system_modes_msgs::srv::GetMode_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<system_modes_msgs::srv::GetMode_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<system_modes_msgs::srv::GetMode_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__system_modes_msgs__srv__GetMode_Event
    std::shared_ptr<system_modes_msgs::srv::GetMode_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__system_modes_msgs__srv__GetMode_Event
    std::shared_ptr<system_modes_msgs::srv::GetMode_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMode_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMode_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMode_Event_

// alias to use template instance with default allocator
using GetMode_Event =
  system_modes_msgs::srv::GetMode_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace system_modes_msgs

namespace system_modes_msgs
{

namespace srv
{

struct GetMode
{
  using Request = system_modes_msgs::srv::GetMode_Request;
  using Response = system_modes_msgs::srv::GetMode_Response;
  using Event = system_modes_msgs::srv::GetMode_Event;
};

}  // namespace srv

}  // namespace system_modes_msgs

#endif  // SYSTEM_MODES_MSGS__SRV__DETAIL__GET_MODE__STRUCT_HPP_
